/*
  Copyright (C) 2003  Taiga Yonekura, taiga@col.hi-ho.ne.jp

  For more information about this appliation please look at:
   http://www.pat.hi-ho.ne.jp/kyonekura

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

import java.util.*;
import javax.microedition.lcdui.*;
import java.io.*;

import java.util.Vector;

// note:
//       LCDTCY zʃTCY tHgTCY A
//J-SH51 130*120      160*160       12*12 
//J-K51  128*128      144*144       12*12/16*16 
//J-T51  144*144      150*150       12*13 
//J-P51  120*130      240*260       12*12/16*16 

public class CalcMng
{
	public static final int CALC_CELL_WIDTH = 30;		//	ȗpZ
	public static final int CALC_CELL_HEIGTH = 32;		//	ȗpZ
	public static final int TIME_CELL_WIDTH  = 15;		//	pZ
	public static final int DAY_CELL_HEIGTH  = 15;		//	jpZ
	
	public static final int VIEW_TIMETABLE_DAY = 3;			//\\
	public static final int VIEW_TIMETABLE_CALC_OF_DAY = 3;	//\\
	
	public static final int CELL_FIELD_START_X = 2;
	public static final int CELL_FIELD_START_Y = 5;

	public static final int DAY_OF_WEEK = 7;
	public static final int CALC_OF_DAY = 8;
	
	
	Jtmtbl app;
	
	private CellViewData cell[];
	private CellView view[];
	Pointer pointer;
	
	int calcTopLeftDay;
	int calcTopLeftTime;
	
	CalcStrage calcStrage;
	
	CalcMng(Jtmtbl main)
	{
		int i,j;
		int day;
		Image img = null;
		Image img2 = null;
		Image img3 = null;
		
		String calcNameStr;
		String calcTeacherStr;
		String calcInfoStr;
		String calcRoomStr;
		
		app = main;
		
		//for MID
		try {
			
			img = Image.createImage("/calcback.png");
			img2 = Image.createImage("/day.png");
			img3 = Image.createImage("/time.png");
			
		}	catch(IOException e) {
			;
        }
        
		calcTopLeftDay = 1;
		calcTopLeftTime = 1;
		pointer = new Pointer(0,0,VIEW_TIMETABLE_DAY+1,VIEW_TIMETABLE_CALC_OF_DAY+1);
		
		cell = new CellViewData[(DAY_OF_WEEK+1)*(CALC_OF_DAY+1)];
		view = new CellView[(VIEW_TIMETABLE_DAY+1)*(VIEW_TIMETABLE_CALC_OF_DAY+1)];
		
		/*j*/
		cell[0] = new DayData(-1);//dummy
		cell[1] = new DayData(Calendar.MONDAY);
		cell[2] = new DayData(Calendar.TUESDAY);
		cell[3] = new DayData(Calendar.WEDNESDAY);
		cell[4] = new DayData(Calendar.THURSDAY);
		cell[5] = new DayData(Calendar.FRIDAY);
		cell[6] = new DayData(Calendar.SATURDAY);
		cell[7] = new DayData(Calendar.SUNDAY);
		
		
		/*Z*/
		for(i=0;i<CALC_OF_DAY;i++){
			cell[8+i*(DAY_OF_WEEK+1)] = new TimeData(i+1);
		}
		
		//Xg[WCX^X̐
		calcStrage = new CalcStrage();
		
		/**/
		for(j=9;j<16;j++){
			
			
			switch(j){
				case 9:
					day = Calendar.MONDAY;
					break;
				case 10:
					day = Calendar.TUESDAY;
					break;
				case 11:
					day = Calendar.WEDNESDAY;
					break;
				case 12:
					day = Calendar.THURSDAY;
					break;
				case 13:
					day = Calendar.FRIDAY;
					break;
				case 14:
					day = Calendar.SATURDAY;
					break;
				case 15:
					day = Calendar.SUNDAY;
					break;
				default:
					day = Calendar.MONDAY;
			}
				
			for(i=0;i<CALC_OF_DAY;i++){
				
				calcNameStr = calcStrage.LoadCalcName(day,i+1);
				calcTeacherStr = calcStrage.LoadCalcTeacher(day,i+1);
				calcInfoStr = calcStrage.LoadCalcInfo(day,i+1);
				calcRoomStr = calcStrage.LoadCalcRoom(day,i+1);
					
				cell[j+i*(DAY_OF_WEEK+1)] = new CalcData(day,i+1,
															calcNameStr,calcTeacherStr,
															calcInfoStr,calcRoomStr);
			}
		}
		//
		//Zr[CX^X̍쐬
		//
		for(i=0;i<(VIEW_TIMETABLE_DAY+1)*(VIEW_TIMETABLE_CALC_OF_DAY+1);i++){
			
			if(i == 0){
				//ԍ
				view[i] 
					= new CellView(CELL_FIELD_START_X,CELL_FIELD_START_Y,
									TIME_CELL_WIDTH,DAY_CELL_HEIGTH,null);
				continue;
			}
			
			if(i >0 && i < VIEW_TIMETABLE_DAY+1){
				//j
				view[i]
					= new CellView(CELL_FIELD_START_X+TIME_CELL_WIDTH+(i-1)*CALC_CELL_WIDTH,
									CELL_FIELD_START_Y,
									CALC_CELL_WIDTH,
									DAY_CELL_HEIGTH,10,0,img2);
				continue;
			}
			
			if((i % (VIEW_TIMETABLE_DAY+1) ) != 0){
				//
				view[i]
					= new CellView(CELL_FIELD_START_X+TIME_CELL_WIDTH
									+(i % (VIEW_TIMETABLE_DAY+1) -1 )*CALC_CELL_WIDTH,
									CELL_FIELD_START_Y+DAY_CELL_HEIGTH
									+ (i/(VIEW_TIMETABLE_DAY+1)-1)*CALC_CELL_HEIGTH,
									CALC_CELL_WIDTH,
									CALC_CELL_HEIGTH,2,2,img);
				continue;
			} else {
				//
				view[i]
					= new CellView(CELL_FIELD_START_X,
									CELL_FIELD_START_Y+DAY_CELL_HEIGTH
									+ (i/(VIEW_TIMETABLE_DAY+1)-1)*CALC_CELL_HEIGTH,
									TIME_CELL_WIDTH,
									CALC_CELL_HEIGTH,5,10,img3);
			}
			
			
		}
		
	}
	
	/*1:j*/
	private void setCellToCellView(int calcTopLeftDay,int calcTopLeftTime)
	{
		int start,i;
		int day,time;
		
		for(i=0;i<(VIEW_TIMETABLE_DAY+1)*(VIEW_TIMETABLE_CALC_OF_DAY+1);i++){
			
			if(i == 0) continue;
			
			if(i >0 && i < VIEW_TIMETABLE_DAY+1){
				
				//Zr[CX^XɃZɓo^(j)
				view[i].setCellData(cell[calcTopLeftDay+(i-1)]);
				continue;
			}
			
			if((i % (VIEW_TIMETABLE_DAY+1) ) != 0){
				
				day = calcTopLeftDay + (i % (VIEW_TIMETABLE_DAY+1)) -1;
				time = calcTopLeftTime + i / (VIEW_TIMETABLE_DAY+1) -1;
				//Zr[CX^XɃZɓo^()
				view[i].setCellData( cell[ day + time*(DAY_OF_WEEK + 1) ]);
				continue;
				
			} else {
				
				// \ = i / (VIEW_TIMETABLE_DAY+1) + calcTopLeftTime-1:̃}X
				// calcTopLeftTime * (DAY_OF_WEEK+1):cell̈ʒu
				view[i].setCellData(cell[(i / (VIEW_TIMETABLE_DAY+1) + calcTopLeftTime-1)
									*(DAY_OF_WEEK+1)]);
			}
			
			
			
			
		}

	}
	
	public void drawCellData(Graphics g)
	{
		int i;
		
		//Zr[CX^XɃZɓo^
		setCellToCellView(calcTopLeftDay,calcTopLeftTime);
		
		for(i=0;i<(VIEW_TIMETABLE_DAY+1)*(VIEW_TIMETABLE_CALC_OF_DAY+1);i++){
			
			view[i].drawCell(g);
			
			String title = view[i].getCellTitle();
			
			if(title.length() < 3){
				
				g.drawString(title,
								view[i].getTitlePos_X(),
								view[i].getTitlePos_Y(),g.TOP | g.LEFT);
								
			} else {
				
				g.drawString(title.substring(0,2),
								view[i].getTitlePos_X(),
								view[i].getTitlePos_Y(),g.TOP | g.LEFT);
								
				if(title.length() == 3){
					//Ȑꍇ
					title = new String(title.substring(2,3));
				}else{
					//Sȏ̏ꍇ
					title = new String(title.substring(2,4));
				}
			
				g.drawString(title,
								view[i].getTitlePos_X(),
								view[i].getTitlePos_Y() + 16,g.TOP | g.LEFT);
			}
			
		}
		
		pointer.drawPointer(g,view[pointer.getIndex()].getPointerPos_X(),
								view[pointer.getIndex()].getPointerPos_Y());
		
	}
	
	public void changeArea(int keyCode)
	{
		int index;
		
		switch(keyCode){
			
			case Canvas.UP:
				if(pointer.movePointerUp() && checkCalcTopLeftTime(calcTopLeftTime-1) ){
					calcTopLeftTime--;
				}
				break;
				
			case Canvas.DOWN:
				if(pointer.movePointerDown() && checkCalcTopLeftTime(calcTopLeftTime+1)){
					calcTopLeftTime++;
				}
				break;
				
			case Canvas.LEFT:
				if(pointer.movePointerLeft() && checkCalcTopLeftDay(calcTopLeftDay-1)){
					calcTopLeftDay--;
				}
				break;
				
			case Canvas.RIGHT:
				if(pointer.movePointerRight() && checkCalcTopLeftDay(calcTopLeftDay+1)){
					calcTopLeftDay++;
				}
				break;
				
			case Canvas.FIRE:
				
				index = pointer.getIndex();
				
				if((0 < index) && (index < VIEW_TIMETABLE_DAY + 1)){
					//j
					Vector vect = new Vector();
					getOneDayCalc(index+calcTopLeftDay-1,vect);
					app.changeCalcDayViewForm(vect);
				} else {
					//ƍ̃}X͎Ȃ
					if((index % (VIEW_TIMETABLE_DAY+1) ) != 0){
						//
						app.changeInputCalcForm(view[pointer.getIndex()].getCellViewData());
					}
				}
				
				
				break;
				
			default:

			}
	}

	private boolean checkCalcTopLeftDay(int day)
	{
		
		if( ( 0 < day ) && ( day <= DAY_OF_WEEK - (VIEW_TIMETABLE_DAY - 1) ) ){
			return true;
		}
		return false;
	}
	
	private boolean checkCalcTopLeftTime(int time)
	{
		
		if( ( 0 < time ) && ( time <= CALC_OF_DAY - ( VIEW_TIMETABLE_CALC_OF_DAY - 1) )){
			return true;
		}
		return false;
	}
	
	private void getOneDayCalc(int dayIdx,Vector vect)
	{
		int startIndex;
		int index,time;
		int i = 1;
		String str;
		CalcData calcData;
		
		startIndex = DAY_OF_WEEK + 1 + dayIdx;
		
		for(i = 0,index=startIndex;i <CALC_OF_DAY;
				index+=(DAY_OF_WEEK+1),i++){
			
			calcData = (CalcData)cell[index];
			time = i+ 1;
			str = "" + time +"";
			vect.addElement(new String(str));
			vect.addElement(new String(" Ɩ:" + calcData.getCalcName()));
			str = " :";
			str += calcData.getCalcRoom();
			vect.addElement(new String(str));
		}
	}
	//
	//
	//
	public CalcStrage getStrage()
	{
		return calcStrage;
	}
	public void exitApplication()
	{
		;
	}
}
