/*
  Copyright (C) 2003  Taiga Yonekura, taiga@col.hi-ho.ne.jp

  For more information about this appliation please look at:
   http://www.pat.hi-ho.ne.jp/kyonekura

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
import java.util.*;

public class CalcStrage{
	
	private String dbName = "CalcStrage";
	private IODriver iodrv;
	
	public CalcStrage()
	{
		iodrv = new IODriver("CalcStrage");
		if(iodrv.checkExistStrage() == false ){
			iodrv.initStrage(CalcMng.DAY_OF_WEEK * CalcMng.CALC_OF_DAY * CalcData.STRAGE_DATA_NUM);
		}

	}
	//
	//	jƎY郌R[hID߂
	//
	private int getCalcRecordID(int dayType,int time)
	{
		int recordID = 1;
		int strageNum = CalcData.STRAGE_DATA_NUM;
		
		if(dayType == Calendar.MONDAY){
			
			recordID = 1 + (time - 1) * strageNum;
			
		} else if(dayType == Calendar.TUESDAY){
			
			recordID = 1 + (CalcMng.CALC_OF_DAY + time - 1) * strageNum;
			
		} else if(dayType == Calendar.WEDNESDAY){
			
			recordID = 1 + (CalcMng.CALC_OF_DAY * 2 + time - 1) * strageNum;
			
		} else if(dayType == Calendar.THURSDAY){
			
			recordID = 1 + (CalcMng.CALC_OF_DAY * 3 + time - 1) * strageNum;
			
		} else if(dayType == Calendar.FRIDAY){
			
			recordID = 1 + (CalcMng.CALC_OF_DAY * 4 + time - 1) * strageNum;
			
		} else if(dayType == Calendar.SATURDAY){
			
			recordID = 1 + (CalcMng.CALC_OF_DAY * 5 + time - 1) * strageNum;
			
		} else if(dayType == Calendar.SUNDAY){
			
			//recordID = CalcMng.CALC_OF_DAY * 6 + time;
			recordID = 1 + (CalcMng.CALC_OF_DAY * 6 + time - 1) * strageNum;
			
		}
		
		return recordID;
	}
	//
	//
	//
	public void SaveCalc(CalcData data,int dayType,int time)
	{
		int recordID = 1;
		byte[] b;
		
		recordID = getCalcRecordID(dayType,time);
		
		//Ɩ
		b = data.getCalcName().getBytes();
		iodrv.saveData(recordID,b);
		
		//St
		b = data.getCalcTeacherStr().getBytes();
		iodrv.saveData(recordID + 1,b);
		
		//
		b = data.getCalcRoom().getBytes();
		iodrv.saveData(recordID + 2,b);
		
		//l
		b = data.getCalcInfoStr().getBytes();
		iodrv.saveData(recordID + 3,b);
		
	}
	//
	// ꊇǂݍ
	//
	public void LoadCalc(CalcData data,int dayType,int time)
	{
		int recordID;
		
		recordID = getCalcRecordID(dayType,time);
		
		//Ɩ
		data.setCalcName(iodrv.loadDataString(recordID));
		
		//St
		data.setCalcTeacher(iodrv.loadDataString(recordID + 1));
		
		//
		data.setCalcRoomStr(iodrv.loadDataString(recordID + 2));
		
		//l
		data.setCalcInfoStr(iodrv.loadDataString(recordID + 3));
		
	}
	//
	//
	//
	public String LoadCalcName(int dayType,int time)
	{
		int recordID;
		
		recordID = getCalcRecordID(dayType,time);
		
		return iodrv.loadDataString(recordID);
	}
	//
	//
	//
	public String LoadCalcTeacher(int dayType,int time)
	{
		int recordID;
		
		recordID = getCalcRecordID(dayType,time);
		
		return iodrv.loadDataString(recordID + 1);
	}
	//
	//
	//
	public String LoadCalcInfo(int dayType,int time)
	{
		int recordID;
		
		recordID = getCalcRecordID(dayType,time);
		
		return iodrv.loadDataString(recordID + 2);
	}
	//
	//
	//
	public String LoadCalcRoom(int dayType,int time)
	{
		int recordID;
		
		recordID = getCalcRecordID(dayType,time);
		
		return iodrv.loadDataString(recordID + 3);
	}
	
	//
	//
	//
	public void SaveCalcName(int dayType,int time,String str)
	{
		int recordID;
		byte[] b;

		recordID = getCalcRecordID(dayType,time);
		
		b = str.getBytes();
		iodrv.saveData(recordID,b);
	}
	//
	//
	//
	public void SaveCalcTeacher(int dayType,int time,String str)
	{
		int recordID;
		byte[] b;
		
		recordID = getCalcRecordID(dayType,time);
		
		b = str.getBytes();
		iodrv.saveData(recordID + 1,b);
	}
	//
	//
	//
	public void SaveCalcInfo(int dayType,int time,String str)
	{
		int recordID;
		byte[] b;
		
		recordID = getCalcRecordID(dayType,time);
		
		b = str.getBytes();
		iodrv.saveData(recordID + 2,b);
	}
	//
	//
	//
	public void SaveCalcRoom(int dayType,int time,String str)
	{
		int recordID;
		byte[] b;
		
		recordID = getCalcRecordID(dayType,time);
		
		b = str.getBytes();
		iodrv.saveData(recordID + 3,b);
	}
	
}
