/*
  Copyright (C) 2003  Taiga Yonekura, taiga@col.hi-ho.ne.jp

  For more information about this appliation please look at:
   http://www.pat.hi-ho.ne.jp/kyonekura

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

import javax.microedition.lcdui.*;

public class CellView
{
	int pos_x;
	int pos_y;
	
	int width;
	int height;
	
	int stringOffsetX;
	int stringOffsetY;
	
	Image img = null;
	
	CellViewData data;
	
	CellView(int x,int y,int wdth,int heht,Image imgData)
	{
		pos_x = x;
		pos_y = y;
		width = wdth;
		height = heht;
		
		img = imgData;
		
		stringOffsetX = 0;
		stringOffsetY = 0;
		
	}
	
	CellView(int x,int y,int wdth,int heht,int offsetx,int offsety,Image imgData)
	{
		pos_x = x;
		pos_y = y;
		width = wdth;
		height = heht;
		
		img = imgData;
		
		stringOffsetX = offsetx;
		stringOffsetY = offsety;
		
	}
	
	public void setCellData(CellViewData cellData)
	{
		data = cellData;
	}
	
	public String getCellTitle()
	{
		if(data != null){
			return data.getViewTitle();
		} else {
			return "";
		}
	}
	
	public int getTitlePos_X()
	{
		return pos_x + stringOffsetX;
	}
	public int getTitlePos_Y()
	{
		return pos_y + stringOffsetY;
	}
	
	public int getPointerPos_X()
	{
		return pos_x + 5;
	}
	public int getPointerPos_Y()
	{
		return pos_y - 5;
	}
	
	public CellViewData getCellViewData()
	{
		return data;
	}
	
	public void drawCell(Graphics g)
	{
		int green,red,blue;
		int type;
		
		if(data != null){
			type = data.getType();
		} else {
			return;
		}
		
		if(CellViewData.TIMEDATA == type){
			red   = 255;
			green = 185;
			blue  = 211;
		} else if(CellViewData.DAYDATA == type){
			red   = 255;
			green = 217;
			blue  = 116;
		} else if(CellViewData.CALCDATA == type){
			red   = 187;
			green = 237;
			blue  = 217;
		} else {
			red   = 255;
			green = 255;
			blue  = 255;
		}
		
		if(img == null){
			g.setColor(red,green,blue);
			g.fillRect(pos_x+1,pos_y+1,width-2,height-1);
			g.setColor(0,0,0);
		} else {
			g.drawImage(img,pos_x,pos_y,g.LEFT);
		}
	}
}