/*
  Copyright (C) 2003  Taiga Yonekura, taiga@col.hi-ho.ne.jp

  For more information about this appliation please look at:
   http://www.pat.hi-ho.ne.jp/kyonekura

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.util.*;

import java.util.Vector;

public final class Jtmtbl extends MIDlet implements Runnable,CommandListener
{
	static final int CALC_MAIN       = 1;
	static final int CALC_INPUT_FORM = 2;
	static final int CALC_DAY_FORM   = 3;
	
	static int dispstatus;
	
	Graphics g2;								//ItXN[
	Image offimage;								//ItXN[C[W
	Screen screen;
	Thread thread;
	
	CalcMng calcMng;
	InputCalcForm inputCalcFrm;
	CalcDayViewForm calcDayViewFrm;
	
	Command selectCmnd;
	Command ExitCmd;
	
	public Jtmtbl()
	{
		init();
	}
	
	public void init()
	{
		dispstatus = CALC_MAIN;
		
		calcMng = new CalcMng(this);
		
		screen = new Screen(calcMng);
		
		Display.getDisplay(this).setCurrent(screen);
	}
	
	public void destroy()
	{
		//
	}
	

	
	//****************
	//C[`
	//****************

	public void run()
	{
		
		screen.repaint();
		try {
			Thread.sleep(5000);
		} catch (InterruptedException e){
			stop();
		}
		screen.startApp();
					
		ExitCmd = new Command("I", Command.SCREEN, 2);
		screen.addCommand(ExitCmd);
		screen.setCommandListener(this);
		
		while(true){
			try {
				
				if(dispstatus == CALC_MAIN){
					screen.repaint();
				}
				Thread.sleep(100);
				
			} catch (InterruptedException e){
				stop();
			}
		}
	}
	
	public void stop()
	{
	}
	
    //Av̊Jn
    public void startApp() {
		
		
		//Xbh
		thread = new Thread(this);
		thread.start();
		
    }

    //Av̈ꎞ~
    public void pauseApp() {
    }

    //Av̏I
    public void destroyApp(boolean unconditional) {
		
		calcMng.exitApplication();
    }

	public static int getDispstatus()
	{
		return dispstatus;
	}
	
	public void commandAction (Command c, Displayable d) 
	{
		
		if (d == inputCalcFrm) {
			
			if (c == selectCmnd ){
				inputCalcFrm.saveData(calcMng.getStrage());
				changeCalcMain();
			} 
			
		} else if(d == calcDayViewFrm ){
			
			if (c == selectCmnd ){
				changeCalcMain();
			} 
			
		} else if(d == screen){

			if (c == ExitCmd ){
				//Av̏I
				destroyApp(true);
				notifyDestroyed();
			}
			
		}
		
	}

	public void changeInputCalcForm(CellViewData data)
	{
		
		this.stop();
		
		selectCmnd = new Command("", Command.SCREEN, 1);
		inputCalcFrm = new InputCalcForm((CalcData)data);
		inputCalcFrm.addCommand(selectCmnd);
		inputCalcFrm.setCommandListener(this);
		
		dispstatus = CALC_INPUT_FORM;
		Display.getDisplay(this).setCurrent(inputCalcFrm);
		

	}
	
	public void changeCalcDayViewForm(Vector vect)
	{
		this.stop();
		
		calcDayViewFrm = new CalcDayViewForm(vect);
		
		selectCmnd = new Command("", Command.SCREEN, 1);
		calcDayViewFrm.addCommand(selectCmnd);
		calcDayViewFrm.setCommandListener(this);
		
		dispstatus = CALC_DAY_FORM;
		Display.getDisplay(this).setCurrent(calcDayViewFrm);
	}
	
	public void changeCalcMain()
	{
		
		Display.getDisplay(this).setCurrent(screen);
		dispstatus = CALC_MAIN;
	}
}