/*
  Copyright (C) 2003  Taiga Yonekura, taiga@col.hi-ho.ne.jp

  For more information about this appliation please look at:
   http://www.pat.hi-ho.ne.jp/kyonekura

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
import javax.microedition.lcdui.*;
import java.io.*;
import java.util.Calendar;


final class Screen extends Canvas /*implements Runnable */
{
	
	static final int SCREENW=144,SCREENH=144;	//ʂ̑傫
	static String panicMessage;
	
	Image offimage;		//ItXN[C[W
	Graphics g2;		//ItXN[
	CalcMng calcMng;
	boolean devInfo = true; //developer Info\
	
	public Screen(CalcMng mng){
		
		super();
		
		calcMng = mng;
	
		panicMessage = null;
		
		offimage = Image.createImage(SCREENW,SCREENH);
		g2 = offimage.getGraphics();
		
	}
	
	//`
	public void paint(Graphics g) {
		
		int status;
		
		//^Cg̕\
		g2.setColor(255,255,255);
		g2.fillRect(0,0,SCREENW,SCREENH);
		
		if(panicMessage != null){
			g2.setColor(255,0,0);
			g2.drawString(panicMessage,0,0,g.LEFT);
		}
		
		drawCell();
		
		
		if(devInfo == true){
			g2.setColor(255,217,116);
			g2.fillRect(20,20,100,70);
			g2.setColor(0,0,0);
			g2.drawString("J-Ԋ Ver2.00",25,30,g.LEFT);
			g2.drawString("(c) 2003 TAIGA",20,45,g.LEFT);
			g.drawImage(offimage,0,0,g.LEFT);
			
		} else {
			drawDate(g2);
			g.drawImage(offimage,0,0,g.LEFT);
		}
	}
	
	public void startApp() 
	{
		devInfo = false;
	}
	//L[vXCxg
	protected synchronized void keyPressed(int keyCode) 
	{
		int status;
		
			calcMng.changeArea(keyCode);
	}
    
	static void panic(String str)
	{
		panicMessage = str;
	}
	
	private void drawDate(Graphics g)
	{
		Calendar cal = Calendar.getInstance(); 
		String str;
		
		int year = cal.get(cal.YEAR);         //N
		int mon = cal.get(cal.MONTH) + 1;     //
		int day = cal.get(cal.DATE);          //
		int hour = cal.get(cal.HOUR_OF_DAY);  // 
		int min = cal.get(cal.MINUTE);        // 
		
		//g.setColor(0,0,0);
		str = " " + year + "/" + mon + "/"  + day + " ";
		if(hour < 10) {
			str = str + "0" + hour + ":";
		} else {
			str = str + hour + ":";
		}
		if(min < 10) {
			str = str + "0" + min;
		} else {
			str = str + min;
		}
		g.drawString(str,5,120,g.LEFT);


	}
	private void drawCell()
	{
		
		g2.setColor(0,0,0);
		//Zf[^̕\
		calcMng.drawCellData(g2);
	}
	

}